// Adaptation of AWM_Beta1's sunlight shock

class LCAdvancedShockRifle expands LCShockRifle;

var bool bGraphicsInitialized;

simulated event Spawned()
{
	if ( !bGraphicsInitialized )
		InitGraphics();
}

simulated function InitGraphics()
{
	local class<ShockRifle> OrgClass;
	local int i;

	default.bGraphicsInitialized = True;
	OrgClass = class<ShockRifle>( DynamicLoadObject("AWM_Beta1.AdvancedShockRifle",class'class') );
	default.AmmoName = OrgClass.default.AmmoName;
	AmmoName = default.AmmoName;
	default.PickupMessage = OrgClass.default.PickupMessage;
	PickupMessage = default.PickupMessage;
	default.AltProjectileClass = OrgClass.default.AltProjectileClass;
	AltProjectileClass = default.AltProjectileClass;

	For ( i=0 ; i<3 ; i++ )
	{
		default.MultiSkins[i] = OrgClass.default.MultiSkins[i];
		MultiSkins[i] = default.MultiSkins[i];
	}

	default.GlobalBeam = class<ShockBeam>( DynamicLoadObject("AWM_Beta1.sunbeam",class'class'));
	default.GlobalExplosion = class<Effects>( DynamicLoadObject("AWM_Beta1.sunexplo",class'class'));
	GlobalBeam = default.GlobalBeam;
	GlobalExplosion = default.GlobalExplosion;
	HiddenBeam.default.Texture = GlobalBeam.default.Texture;
	HiddenExplosion.default.Texture = GlobalExplosion.default.Texture;
}


defaultproperties
{
    HiddenBeam=class'LCSunBeam'
    HiddenExplosion=class'LCSunExplo'
    HitDamage=100
    PickupAmmoCount=40
}
