class XC_CProjSN expands SpawnNotify;

var XC_CompensatorChannel Channel;
var XC_ElementAdvancer Advancer;
var Projectile Stored[256];
var float RemainingAdv[256];
var int iStored;

function Setup( XC_CompensatorChannel COwner, XC_ElementAdvancer EAdv)
{
	Channel = COwner;
	Advancer = EAdv;
}

event Actor SpawnNotification( Actor A)
{
	if ( (A.default.bNetTemporary || A.default.RemoteRole == ROLE_SimulatedProxy) && (Channel.ProjAdv > 0) )
	{
		RemainingAdv[iStored] = Channel.ProjAdv;
		Stored[iStored++] = Projectile(A);
	}
	else if ( !A.default.bNetTemporary && Channel.ProjAdv > 0 ) //Shock balls?
		Advancer.RegisterAdvance( A);
	return A;
}

event Tick( float DeltaTime)
{
	local int i;
	local float RemAdj;

	RemAdj = fClamp( DeltaTime / Level.TimeDilation, 0.01, 0.05) * Level.TimeDilation;

	while ( i<iStored )
	{
		if ( Stored[i] == none || Stored[i].bDeleteMe )
		{
			REMOVE_ELEMENT:
			Stored[i] = Stored[--iStored];
			RemainingAdv[i] = RemainingAdv[iStored];
			Stored[iStored] = none;
			continue;
		}
		
		if ( RemainingAdv[i] <= 0 || Stored[i].Velocity == Vect(0,0,0) )
			Goto REMOVE_ELEMENT;
		if ( RemainingAdv[i] > RemAdj )
		{
			RemainingAdv[i] -= RemAdj;
			Stored[i].AutonomousPhysics( RemAdj);
		}
		else
		{
			Stored[i].AutonomousPhysics( RemainingAdv[i]);
			Goto REMOVE_ELEMENT;
		}
		i++;
	}

/*	For ( i=0 ; i<iStored ; i++ )
	{
		if ( Stored[i] == none )
			continue;
		Remaining = Channel.ProjAdv;
		while ( Remaining > 0 )
		{
			Stored[i].AutonomousPhysics( Channel.ProjAdv);
		}
		Stored[i] = none;
	}*/
}


defaultproperties
{
    ActorClass=class'Projectile'
    RemoteRole=ROLE_None
}